{%- macro vote(entity, vote_path) -%}
  {{- block('vote') -}}
{%- endmacro -%}

{%- block vote -%}
  {%- set user_vote = is_granted('ROLE_USER') ? entity.userVote(app.user) : null -%}
  {%- spaceless -%}
    <form action="{{ vote_path }}" method="post" class="vote {{ block('vote_class') }}" data-score="{{ entity.netScore }}">
      <input type="hidden" name="token" value="{{ csrf_token('vote') }}">

      <button type="submit" name="choice" value="{{ block('vote_choice_up') }}"
              class="vote-button vote-up" title="{{ block('vote_up_label') }}">
        {#- http://mts.io/2015/04/21/unicode-symbol-render-text-emoji/ -#}
        <span class="inner" aria-hidden="true">&#x2B06;&#xFE0E;</span>
      </button>

      <span class="vote-score">{{ entity.netScore }}</span>

      <button type="submit" name="choice" value="{{ block('vote_choice_down') }}"
              class="vote-button vote-down" title="{{ block('vote_down_label') }}">
        <span class="inner" aria-hidden="true">&#x2B07;&#xFE0E;</span>
      </button>
    </form>
  {%- endspaceless -%}
{%- endblock -%}

{%- block vote_class -%}
  {%- if not user_vote -%}
    {#- nothing -#}
  {%- elseif user_vote.upvote -%}
    vote-user-upvoted
  {%- else -%}
    vote-user-downvoted
  {%- endif -%}
{%- endblock -%}

{%- block vote_choice_up -%}
  {{- user_vote and user_vote.upvote ? 0 : 1 -}}
{%- endblock -%}

{%- block vote_choice_down -%}
  {{- user_vote and not user_vote.upvote ? 0 : -1 -}}
{%- endblock -%}

{%- block vote_up_label -%}
  {{- (user_vote and user_vote.upvote ? 'votes.retract_upvote' : 'votes.upvote')|trans -}}
{%- endblock -%}

{%- block vote_down_label -%}
  {{- (user_vote and not user_vote.upvote ? 'votes.retract_downvote' : 'votes.downvote')|trans -}}
{%- endblock -%}
